# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from logicmonitor_sdk.models.name_and_value import NameAndValue  # noqa: F401,E501


class CollectorGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'create_on': 'int',
        'custom_properties': 'list[NameAndValue]',
        'description': 'str',
        'id': 'int',
        'name': 'str',
        'num_of_collectors': 'int',
        'user_permission': 'str'
    }

    attribute_map = {
        'create_on': 'createOn',
        'custom_properties': 'customProperties',
        'description': 'description',
        'id': 'id',
        'name': 'name',
        'num_of_collectors': 'numOfCollectors',
        'user_permission': 'userPermission'
    }

    def __init__(self, create_on=None, custom_properties=None, description=None, id=None, name=None, num_of_collectors=None, user_permission=None):  # noqa: E501
        """CollectorGroup - a model defined in Swagger"""  # noqa: E501

        self._create_on = None
        self._custom_properties = None
        self._description = None
        self._id = None
        self._name = None
        self._num_of_collectors = None
        self._user_permission = None
        self.discriminator = None

        if create_on is not None:
            self.create_on = create_on
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if description is not None:
            self.description = description
        if id is not None:
            self.id = id
        self.name = name
        if num_of_collectors is not None:
            self.num_of_collectors = num_of_collectors
        if user_permission is not None:
            self.user_permission = user_permission

    @property
    def create_on(self):
        """Gets the create_on of this CollectorGroup.  # noqa: E501

        The time at which the group was created, in epoch format  # noqa: E501

        :return: The create_on of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._create_on

    @create_on.setter
    def create_on(self, create_on):
        """Sets the create_on of this CollectorGroup.

        The time at which the group was created, in epoch format  # noqa: E501

        :param create_on: The create_on of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._create_on = create_on

    @property
    def custom_properties(self):
        """Gets the custom_properties of this CollectorGroup.  # noqa: E501

        The custom properties defined for the Collector group  # noqa: E501

        :return: The custom_properties of this CollectorGroup.  # noqa: E501
        :rtype: list[NameAndValue]
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this CollectorGroup.

        The custom properties defined for the Collector group  # noqa: E501

        :param custom_properties: The custom_properties of this CollectorGroup.  # noqa: E501
        :type: list[NameAndValue]
        """

        self._custom_properties = custom_properties

    @property
    def description(self):
        """Gets the description of this CollectorGroup.  # noqa: E501

        The description of the Collector Group  # noqa: E501

        :return: The description of this CollectorGroup.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CollectorGroup.

        The description of the Collector Group  # noqa: E501

        :param description: The description of this CollectorGroup.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this CollectorGroup.  # noqa: E501

        The id of the Collector Group  # noqa: E501

        :return: The id of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CollectorGroup.

        The id of the Collector Group  # noqa: E501

        :param id: The id of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this CollectorGroup.  # noqa: E501

        The name of the Collector Group  # noqa: E501

        :return: The name of this CollectorGroup.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CollectorGroup.

        The name of the Collector Group  # noqa: E501

        :param name: The name of this CollectorGroup.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def num_of_collectors(self):
        """Gets the num_of_collectors of this CollectorGroup.  # noqa: E501

        The number of Collectors that belong to the group  # noqa: E501

        :return: The num_of_collectors of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._num_of_collectors

    @num_of_collectors.setter
    def num_of_collectors(self, num_of_collectors):
        """Sets the num_of_collectors of this CollectorGroup.

        The number of Collectors that belong to the group  # noqa: E501

        :param num_of_collectors: The num_of_collectors of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._num_of_collectors = num_of_collectors

    @property
    def user_permission(self):
        """Gets the user_permission of this CollectorGroup.  # noqa: E501

        The permission level of the user that made the API request  # noqa: E501

        :return: The user_permission of this CollectorGroup.  # noqa: E501
        :rtype: str
        """
        return self._user_permission

    @user_permission.setter
    def user_permission(self, user_permission):
        """Sets the user_permission of this CollectorGroup.

        The permission level of the user that made the API request  # noqa: E501

        :param user_permission: The user_permission of this CollectorGroup.  # noqa: E501
        :type: str
        """

        self._user_permission = user_permission

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CollectorGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CollectorGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
