# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from logicmonitor_sdk.models.exclude_duplicate_ips import ExcludeDuplicateIps  # noqa: F401,E501
from logicmonitor_sdk.models.rest_schedule import RestSchedule  # noqa: F401,E501


class Netscan(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'collector': 'int',
        'collector_description': 'str',
        'collector_group': 'int',
        'collector_group_name': 'str',
        'creator': 'str',
        'description': 'str',
        'duplicate': 'ExcludeDuplicateIps',
        'group': 'str',
        'id': 'int',
        'method': 'str',
        'name': 'str',
        'next_start': 'str',
        'next_start_epoch': 'int',
        'nsg_id': 'int',
        'schedule': 'RestSchedule',
        'version': 'int'
    }

    attribute_map = {
        'collector': 'collector',
        'collector_description': 'collectorDescription',
        'collector_group': 'collectorGroup',
        'collector_group_name': 'collectorGroupName',
        'creator': 'creator',
        'description': 'description',
        'duplicate': 'duplicate',
        'group': 'group',
        'id': 'id',
        'method': 'method',
        'name': 'name',
        'next_start': 'nextStart',
        'next_start_epoch': 'nextStartEpoch',
        'nsg_id': 'nsgId',
        'schedule': 'schedule',
        'version': 'version'
    }

    discriminator_value_class_map = {
        'script': 'ScriptNetscan',
        'gcp': 'GCPNetscan',
        'azure': 'AzureNetscan',
        'nec2': 'Ec2Netscan',
        'nmap': 'NMapNetscan',
        'aws': 'AWSNetscan'
    }

    def __init__(self, collector=None, collector_description=None, collector_group=None, collector_group_name=None, creator=None, description=None, duplicate=None, group=None, id=None, method=None, name=None, next_start=None, next_start_epoch=None, nsg_id=None, schedule=None, version=None):  # noqa: E501
        """Netscan - a model defined in Swagger"""  # noqa: E501

        self._collector = None
        self._collector_description = None
        self._collector_group = None
        self._collector_group_name = None
        self._creator = None
        self._description = None
        self._duplicate = None
        self._group = None
        self._id = None
        self._method = None
        self._name = None
        self._next_start = None
        self._next_start_epoch = None
        self._nsg_id = None
        self._schedule = None
        self._version = None
        self.discriminator = 'method'

        self.collector = collector
        if collector_description is not None:
            self.collector_description = collector_description
        if collector_group is not None:
            self.collector_group = collector_group
        if collector_group_name is not None:
            self.collector_group_name = collector_group_name
        if creator is not None:
            self.creator = creator
        if description is not None:
            self.description = description
        self.duplicate = duplicate
        if group is not None:
            self.group = group
        if id is not None:
            self.id = id
        self.method = method
        self.name = name
        if next_start is not None:
            self.next_start = next_start
        if next_start_epoch is not None:
            self.next_start_epoch = next_start_epoch
        if nsg_id is not None:
            self.nsg_id = nsg_id
        if schedule is not None:
            self.schedule = schedule
        if version is not None:
            self.version = version

    @property
    def collector(self):
        """Gets the collector of this Netscan.  # noqa: E501

        The ID of the Collector associated with this Netscan  # noqa: E501

        :return: The collector of this Netscan.  # noqa: E501
        :rtype: int
        """
        return self._collector

    @collector.setter
    def collector(self, collector):
        """Sets the collector of this Netscan.

        The ID of the Collector associated with this Netscan  # noqa: E501

        :param collector: The collector of this Netscan.  # noqa: E501
        :type: int
        """
        if collector is None:
            raise ValueError("Invalid value for `collector`, must not be `None`")  # noqa: E501

        self._collector = collector

    @property
    def collector_description(self):
        """Gets the collector_description of this Netscan.  # noqa: E501

        The description of the Collector associated with this Netscan  # noqa: E501

        :return: The collector_description of this Netscan.  # noqa: E501
        :rtype: str
        """
        return self._collector_description

    @collector_description.setter
    def collector_description(self, collector_description):
        """Sets the collector_description of this Netscan.

        The description of the Collector associated with this Netscan  # noqa: E501

        :param collector_description: The collector_description of this Netscan.  # noqa: E501
        :type: str
        """

        self._collector_description = collector_description

    @property
    def collector_group(self):
        """Gets the collector_group of this Netscan.  # noqa: E501

        The ID of the group of the Collector associated with this Netscan  # noqa: E501

        :return: The collector_group of this Netscan.  # noqa: E501
        :rtype: int
        """
        return self._collector_group

    @collector_group.setter
    def collector_group(self, collector_group):
        """Sets the collector_group of this Netscan.

        The ID of the group of the Collector associated with this Netscan  # noqa: E501

        :param collector_group: The collector_group of this Netscan.  # noqa: E501
        :type: int
        """

        self._collector_group = collector_group

    @property
    def collector_group_name(self):
        """Gets the collector_group_name of this Netscan.  # noqa: E501

        The name of the group of the Collector associated with this Netscan  # noqa: E501

        :return: The collector_group_name of this Netscan.  # noqa: E501
        :rtype: str
        """
        return self._collector_group_name

    @collector_group_name.setter
    def collector_group_name(self, collector_group_name):
        """Sets the collector_group_name of this Netscan.

        The name of the group of the Collector associated with this Netscan  # noqa: E501

        :param collector_group_name: The collector_group_name of this Netscan.  # noqa: E501
        :type: str
        """

        self._collector_group_name = collector_group_name

    @property
    def creator(self):
        """Gets the creator of this Netscan.  # noqa: E501

        The user that created the policy  # noqa: E501

        :return: The creator of this Netscan.  # noqa: E501
        :rtype: str
        """
        return self._creator

    @creator.setter
    def creator(self, creator):
        """Sets the creator of this Netscan.

        The user that created the policy  # noqa: E501

        :param creator: The creator of this Netscan.  # noqa: E501
        :type: str
        """

        self._creator = creator

    @property
    def description(self):
        """Gets the description of this Netscan.  # noqa: E501

        The description of the Netscan Policy  # noqa: E501

        :return: The description of this Netscan.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Netscan.

        The description of the Netscan Policy  # noqa: E501

        :param description: The description of this Netscan.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def duplicate(self):
        """Gets the duplicate of this Netscan.  # noqa: E501

        Information that determines how duplicate discovered devices should be handled  # noqa: E501

        :return: The duplicate of this Netscan.  # noqa: E501
        :rtype: ExcludeDuplicateIps
        """
        return self._duplicate

    @duplicate.setter
    def duplicate(self, duplicate):
        """Sets the duplicate of this Netscan.

        Information that determines how duplicate discovered devices should be handled  # noqa: E501

        :param duplicate: The duplicate of this Netscan.  # noqa: E501
        :type: ExcludeDuplicateIps
        """
        if duplicate is None:
            raise ValueError("Invalid value for `duplicate`, must not be `None`")  # noqa: E501

        self._duplicate = duplicate

    @property
    def group(self):
        """Gets the group of this Netscan.  # noqa: E501

        The group the Netscan policy should belong to  # noqa: E501

        :return: The group of this Netscan.  # noqa: E501
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this Netscan.

        The group the Netscan policy should belong to  # noqa: E501

        :param group: The group of this Netscan.  # noqa: E501
        :type: str
        """

        self._group = group

    @property
    def id(self):
        """Gets the id of this Netscan.  # noqa: E501

        The ID of the Netscan Policy  # noqa: E501

        :return: The id of this Netscan.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Netscan.

        The ID of the Netscan Policy  # noqa: E501

        :param id: The id of this Netscan.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def method(self):
        """Gets the method of this Netscan.  # noqa: E501

        The method that should be used to discover devices. Options are nmap (ICMP Ping), nec2 (EC2), and script  # noqa: E501

        :return: The method of this Netscan.  # noqa: E501
        :rtype: str
        """
        return self._method

    @method.setter
    def method(self, method):
        """Sets the method of this Netscan.

        The method that should be used to discover devices. Options are nmap (ICMP Ping), nec2 (EC2), and script  # noqa: E501

        :param method: The method of this Netscan.  # noqa: E501
        :type: str
        """
        if method is None:
            raise ValueError("Invalid value for `method`, must not be `None`")  # noqa: E501

        self._method = method

    @property
    def name(self):
        """Gets the name of this Netscan.  # noqa: E501

        The name of the Netscan Policy  # noqa: E501

        :return: The name of this Netscan.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Netscan.

        The name of the Netscan Policy  # noqa: E501

        :param name: The name of this Netscan.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def next_start(self):
        """Gets the next_start of this Netscan.  # noqa: E501

        The date and time of the next start time of the scan - displayed as manual if the scan does not run on a schedule  # noqa: E501

        :return: The next_start of this Netscan.  # noqa: E501
        :rtype: str
        """
        return self._next_start

    @next_start.setter
    def next_start(self, next_start):
        """Sets the next_start of this Netscan.

        The date and time of the next start time of the scan - displayed as manual if the scan does not run on a schedule  # noqa: E501

        :param next_start: The next_start of this Netscan.  # noqa: E501
        :type: str
        """

        self._next_start = next_start

    @property
    def next_start_epoch(self):
        """Gets the next_start_epoch of this Netscan.  # noqa: E501

        The epoch of the next start time of the scan - displayed as 0 if the scan does not run on a schedule  # noqa: E501

        :return: The next_start_epoch of this Netscan.  # noqa: E501
        :rtype: int
        """
        return self._next_start_epoch

    @next_start_epoch.setter
    def next_start_epoch(self, next_start_epoch):
        """Sets the next_start_epoch of this Netscan.

        The epoch of the next start time of the scan - displayed as 0 if the scan does not run on a schedule  # noqa: E501

        :param next_start_epoch: The next_start_epoch of this Netscan.  # noqa: E501
        :type: int
        """

        self._next_start_epoch = next_start_epoch

    @property
    def nsg_id(self):
        """Gets the nsg_id of this Netscan.  # noqa: E501

        The ID of the group the policy belongs to  # noqa: E501

        :return: The nsg_id of this Netscan.  # noqa: E501
        :rtype: int
        """
        return self._nsg_id

    @nsg_id.setter
    def nsg_id(self, nsg_id):
        """Sets the nsg_id of this Netscan.

        The ID of the group the policy belongs to  # noqa: E501

        :param nsg_id: The nsg_id of this Netscan.  # noqa: E501
        :type: int
        """

        self._nsg_id = nsg_id

    @property
    def schedule(self):
        """Gets the schedule of this Netscan.  # noqa: E501

        Information related to the recurring execution schedule for the Netscan Policy  # noqa: E501

        :return: The schedule of this Netscan.  # noqa: E501
        :rtype: RestSchedule
        """
        return self._schedule

    @schedule.setter
    def schedule(self, schedule):
        """Sets the schedule of this Netscan.

        Information related to the recurring execution schedule for the Netscan Policy  # noqa: E501

        :param schedule: The schedule of this Netscan.  # noqa: E501
        :type: RestSchedule
        """

        self._schedule = schedule

    @property
    def version(self):
        """Gets the version of this Netscan.  # noqa: E501

        The Id of the device  # noqa: E501

        :return: The version of this Netscan.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Netscan.

        The Id of the device  # noqa: E501

        :param version: The version of this Netscan.  # noqa: E501
        :type: int
        """

        self._version = version

    def get_real_child_model(self, data):
        """Returns the real base class specified by the discriminator"""
        discriminator_value = data[self.discriminator].lower()
        return self.discriminator_value_class_map.get(discriminator_value)

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Netscan, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Netscan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
